diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
index 3353e308d..96da2d4e7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
@@ -51,7 +51,7 @@ public class AchievementPageNether extends AchievementPage {
         final int offsetY = tileY + random.nextInt(3) - random.nextInt(3);
 
         int r = random.nextInt(50);
-        IconCoordinate texture = getTextureFromBlock(Blocks.COBBLE_NETHERRACK);
+        IconCoordinate texture = random.nextBoolean() ? getTextureFromBlock(Blocks.NETHERRACK) : getTextureFromBlock(Blocks.COBBLE_NETHERRACK);
         if (offsetY >= bedrockLayer) {
             texture = getTextureFromBlock(Blocks.BEDROCK);
         } else if (r < 10) {
@@ -86,6 +86,15 @@ public class AchievementPageNether extends AchievementPage {
                 cave--;
             }
 
+        } else if (layerCache.id == 1) {
+            // Remove covered icons so the deeper layer only shows through carved caves
+            IconCoordinate[] foreground = screen.getLayer(0).getData();
+            IconCoordinate[] background = layerCache.getData();
+            for (int i = 0; i < background.length; i++) {
+                if (foreground[i] != null){
+                    background[i] = null;
+                }
+            }
         }
     }
 
@@ -96,7 +105,7 @@ public class AchievementPageNether extends AchievementPage {
 
     @Override
     public int backgroundLayers() {
-        return 1;
+        return 2;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 9bef9bdc4..1f646c930 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -225,7 +225,7 @@ public class ScreenFlagEditor
             this.colorLabels[this.selectedColor].setTextColor(0xFF404040);
             this.colorLabels[this.selectedColor].setShadow(false);
             this.selectedColor = button.id - 100;
-            this.colorLabels[this.selectedColor].setTextColor(0xFFFFFFF);
+            this.colorLabels[this.selectedColor].setTextColor(0xFFFFFFFF);
             this.colorLabels[this.selectedColor].setShadow(true);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index f93d80aea..05f044b47 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -86,7 +86,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         this.mc.currentWorld.entities.clear();
         this.mc.currentWorld.tileEntityList.clear();
         this.mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
-        this.mc.thePlayer.noPhysics = true;
+        this.mc.thePlayer.setNoclip(true);
         this.mc.textureManager.refreshTexturesAndDisplayErrors();
         this.mc.textureManager.updateDynamicTextures(false);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
index ad43af76d..60f1217b3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
@@ -195,7 +195,7 @@ public class ViewerCategoryEntity extends ModelViewerCategory<ModelViewerCategor
         removeDisplayEntity();
         displayEntity = entity;
         if (displayEntity != null){
-            displayEntity.noPhysics = true;
+            displayEntity.setNoPhysics(true);
 
             displayEntity.absMoveTo(mc.thePlayer.x, mc.thePlayer.y + mc.thePlayer.getHeadHeight() - displayEntity.bbHeight/2, mc.thePlayer.z, displayEntity.yRot, displayEntity.xRot);
             displayEntity.lerpMotion(0, 0, 0);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 1481a19ca..d2dbd742c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -3,6 +3,10 @@ package net.minecraft.client.gui.options.data;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.NbtIo;
 import net.betterthanadventure.utils.DataDumper;
+import net.betterthanadventure.utils.DumpFolder;
+import net.betterthanadventure.utils.InvSpriteAPNGDumper;
+import net.betterthanadventure.utils.InvSpriteDumper;
+import net.betterthanadventure.utils.WikiDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenControllerSetup;
 import net.minecraft.client.gui.ScreenFontTest;
@@ -39,12 +43,12 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.useless.seedviewer.SeedViewerMain;
 import paulscode.sound.SoundSystem;
 
 import java.io.File;
 import java.io.IOException;
-import java.util.Collections;
 import java.util.List;
 
 
@@ -417,9 +421,61 @@ public abstract class OptionsPages {
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () -> {
                     DataDumper.main(new String[0]);
-                    FileOpener.open(new File(mc.getMinecraftDir(), "infodump"));
+                    FileOpener.open(new File(mc.getMinecraftDir(), DumpFolder.NAME));
                     Global.accessor = mc;
                 }))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.dump.wiki", () -> {
+                    try {
+                        WikiDumper.dump(mc.getMinecraftDir());
+                        FileOpener.open(new File(mc.getMinecraftDir(), DumpFolder.NAME));
+                    } catch (IOException e) {
+                        LogUtils.getLogger().error("Failed to write wiki dump", e);
+                    }
+                }))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.dump.invsprite", () -> {
+                    if (mc.currentWorld == null) return; // Biome/season tints only resolve inside a world
+                    try {
+                        FileOpener.open(InvSpriteDumper.dump(mc.getMinecraftDir()));
+                    } catch (IOException e) {
+                        LogUtils.getLogger().error("Failed to write inventory sprite dump", e);
+                    }
+                }) {
+                    private boolean hovered = false;
+
+                    @Override
+                    public void render(@NotNull ScreenOptions screenOptions, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                        this.button.enabled = mc.currentWorld != null;
+                        this.hovered = relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 0 && relativeMouseY <= getHeight();
+                        super.render(screenOptions, x, y, width, relativeMouseX, relativeMouseY);
+                    }
+
+                    @Override
+                    public @Nullable String getTooltipTranslationKey() {
+                        return (this.hovered && mc.currentWorld == null) ? "gui.options.page.debug.button.dump.invsprite.tooltip" : null;
+                    }
+                })
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.dump.invsprite_apng", () -> {
+                    if (mc.currentWorld == null) return; // Biome/season tints only resolve inside a world.
+                    try {
+                        FileOpener.open(InvSpriteAPNGDumper.dump(mc.getMinecraftDir()));
+                    } catch (IOException e) {
+                        LogUtils.getLogger().error("Failed to write animated inventory sprite dump", e);
+                    }
+                }) {
+                    private boolean hovered = false;
+
+                    @Override
+                    public void render(@NotNull ScreenOptions screenOptions, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                        this.button.enabled = mc.currentWorld != null;
+                        this.hovered = relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 0 && relativeMouseY <= getHeight();
+                        super.render(screenOptions, x, y, width, relativeMouseX, relativeMouseY);
+                    }
+
+                    @Override
+                    public @Nullable String getTooltipTranslationKey() {
+                        return (this.hovered && mc.currentWorld == null) ? "gui.options.page.debug.button.dump.invsprite.tooltip" : null;
+                    }
+                })
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.achievements", () -> mc.displayScreen(new ScreenAchievements(mc.currentScreen, mc.statsCounter))))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.test")
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 9cecac3bd..ad2554f33 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.gui.popup;
 
+import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -17,15 +19,27 @@ import net.minecraft.core.util.helper.MathHelper;
 public class ListComponent
     extends InteractivePopupComponent<Integer> {
     private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
+
     private int selectedItem;
     private float scrollAmount = 0;
-    private final @NotNull ButtonElement @NotNull [] buttons;
+
+    private final @NotNull ButtonElement @NotNull [] unfilteredButtons;
+    private final @NotNull String @Nullable [] unfilteredButtonTooltips;
+
+    // These hold the buttons after the filter is applied. You SHOULD use these.
+    private ButtonElement[] filteredButtons = null;
+    private int[] filteredButtonsIndexes = null;
+
+    // permanent buffer for the search so we avoid allocating. Do NOT use.
+    private final @NotNull ButtonElement @NotNull [] temporaryFilterButtonBuffer;
+    private final int @NotNull [] temporaryFilterIndexBuffer;
+
     private final int height;
     private int lastX = 0;
     private int lastY = 0;
     private final boolean closeOnItemSelected;
     private final @NotNull TooltipElement tooltip;
-    private final @NotNull String @Nullable [] buttonTooltips;
+
 
     private int scrollbarX;
     private int scrollbarY;
@@ -35,6 +49,8 @@ public class ListComponent
     private int clickY;
     private float previousScrollAmount = 0.0f;
 
+    private TextFieldElement searchBar = null;
+
     public ListComponent(
         final int width,
         final int height,
@@ -47,25 +63,67 @@ public class ListComponent
 
         this.height = height;
         this.closeOnItemSelected = closeOnItemSelected;
+
         assert this.minecraft != null;
+
         this.tooltip = new TooltipElement(this.minecraft);
+        this.searchBar = new TextFieldElement(this.getParent(), this.minecraft.font, 0, 0, this.getWidth(), 20, "", I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
 
         this.selectedItem = selectedItem;
-        this.buttonTooltips = buttonTooltips;
+        this.unfilteredButtonTooltips = buttonTooltips;
 
-        this.buttons = new ButtonElement[buttonLabels.length];
-        for (int i = 0; i < this.buttons.length; i++) {
-            this.buttons[i] = new ButtonElement(i, 0, 0, width - 2 - 6, 20, buttonLabels[i]);
+        this.unfilteredButtons = new ButtonElement[buttonLabels.length];
+        for (int i = 0; i < this.unfilteredButtons.length; i++) {
+            this.unfilteredButtons[i] = new ButtonElement(i, 0, 0, width - 2 - 6, 20, buttonLabels[i]);
             if (i == selectedItem) {
-                this.buttons[i].enabled = false;
+                this.unfilteredButtons[i].enabled = false;
             }
         }
 
         // Scroll so selected item is in view
         final float ratio = (float) (this.getScrollableHeight() + this.height) / this.getScrollableHeight();
-        float sc = (selectedItem / (float) (this.buttons.length - 4)) * ratio;
+        float sc = (selectedItem / (float) (this.unfilteredButtons.length - 4)) * ratio;
         sc -= ((float) this.height / this.getScrollableHeight());
         this.scroll(sc);
+
+        this.temporaryFilterButtonBuffer = new ButtonElement[this.unfilteredButtons.length];
+        this.temporaryFilterIndexBuffer  = new int[this.unfilteredButtons.length];
+
+        updateButtonFilter();
+        this.searchBar.setTextChangeListener(textFieldElement -> updateButtonFilter());
+    }
+
+    // I doubt this is a very good filter allocation wise. But this isn't performance critical anyway.
+    // - kheppy
+    private boolean filterString(String filter, String input) {
+        return input.toLowerCase().contains(filter.toLowerCase());
+    }
+
+    public void updateButtonFilter() {
+        int count = 0;
+
+        for (int i = 0; i < this.unfilteredButtons.length; i++) {
+            var btn = this.unfilteredButtons[i];
+
+            if (filterString(this.searchBar.getText(), btn.displayString)) {
+                temporaryFilterButtonBuffer[count] = btn;
+                temporaryFilterIndexBuffer[count] = i;
+                count += 1;
+            }
+        }
+
+        if (this.filteredButtons == null || this.filteredButtons.length != count) {
+            this.scrollAmount = 0;
+            this.filteredButtons = new ButtonElement[count];
+            this.filteredButtonsIndexes = new int[count];
+        }
+
+        System.arraycopy(temporaryFilterButtonBuffer, 0, this.filteredButtons, 0, count);
+        System.arraycopy(temporaryFilterIndexBuffer, 0, this.filteredButtonsIndexes, 0, count);
+    }
+
+    private int getSearchBarOffset() {
+        return this.searchBar.height + 5;
     }
 
     private boolean canScroll() {
@@ -95,32 +153,39 @@ public class ListComponent
         this.lastX = x;
         this.lastY = y;
 
+        this.searchBar.xPosition = x;
+        this.searchBar.yPosition = y;
+        this.searchBar.drawTextBox();
+        this.searchBar.updateCursor(Minecraft.getMinecraft(), mouseX, mouseY);
+
         // Do scroll
         if (this.canScroll() && this.mouseInRegion(x, y, mouseX, mouseY)) {
             final float wheel = Mouse.getDWheel();
             if (wheel != 0.0f)
                 this.scroll(wheel / -12.0f);
         }
+
         GLRenderer.pushFrame();
         GLRenderer.setShader(Shaders.COLOR);
-        this.drawBackground(x, y);
-        this.drawScrollbar(x, y, mouseY);
+        this.drawBackground(x, y + getSearchBarOffset());
+        this.drawScrollbar(x, y + getSearchBarOffset(), mouseY);
 
         GLRenderer.popFrame();
 
-        Scissor.enable(x + 1, y + 1, this.getWidth() - 2, this.getHeight() - 2);
+        Scissor.enable(x + 1, y + getSearchBarOffset() + 1, this.getWidth() - 2, this.getHeight() - 2 - getSearchBarOffset());
 
         // Draw buttons
-        for (int i = 0; i < this.buttons.length; i++) {
+        for (int i = 0; i < this.filteredButtons.length; ++i) {
             if (this.canScroll()) {
-                this.buttons[i].width = this.getWidth() - 2 - 6;
+                this.filteredButtons[i].width = this.getWidth() - 2 - 6;
             } else {
-                this.buttons[i].width = this.getWidth() - 2;
+                this.filteredButtons[i].width = this.getWidth() - 2;
             }
 
-            final ButtonElement button = this.buttons[i];
+            ButtonElement button = this.filteredButtons[i];
             button.xPosition = x + 1;
-            button.yPosition = (y + 1) + (i * 20) - this.getScrollPixels();
+            button.yPosition = (y + getSearchBarOffset() + 1) + i * 20 - this.getScrollPixels();
+
             if (this.mouseInRegion(x, y, mouseX, mouseY)) {
                 button.drawButton(this.minecraft, mouseX, mouseY);
             } else {
@@ -130,13 +195,17 @@ public class ListComponent
 
         Scissor.disable();
 
-        if (this.buttonTooltips != null && this.mouseInRegion(x, y, mouseX, mouseY)) {
-            for (int i = 0; i < this.buttons.length; i++) {
-                final ButtonElement button = this.buttons[i];
+        if (this.unfilteredButtonTooltips != null && this.mouseInRegion(x, y, mouseX, mouseY)) {
+
+            for(int i = 0; i < this.filteredButtons.length; ++i) {
+                ButtonElement button = this.filteredButtons[i];
+
                 if (button.isHovered(mouseX, mouseY)) {
-                    this.tooltip.render(this.buttonTooltips[i], mouseX, mouseY, 0, 0);
+                    final int buttonIndex = this.filteredButtonsIndexes[i];
+                    this.tooltip.render(this.unfilteredButtonTooltips[buttonIndex], mouseX, mouseY, 0, 0);
                     break;
                 }
+
             }
         }
     }
@@ -146,17 +215,19 @@ public class ListComponent
     }
 
     private int getScrollPixels() {
-        return (int) (this.scrollAmount * (this.getScrollableHeight() - (this.height - 2)));
+        return (int) (this.scrollAmount * (this.getScrollableHeight() - (this.height - 2 - this.getSearchBarOffset())));
     }
 
     private int getScrollableHeight() {
-        return 20 * this.buttons.length;
+        return 20 * (this.filteredButtons != null ? this.filteredButtons.length : this.unfilteredButtons.length);
     }
 
     @Override
     public void onClick(final int x, final int y, final int button) {
         super.onClick(x, y, button);
 
+        this.searchBar.mouseClicked(x, y, button);
+
         final int scrollableHeight = this.getScrollableHeight();
         final int displayRegionHeight = this.height - 2;
         final boolean canScroll = scrollableHeight > displayRegionHeight;
@@ -169,9 +240,9 @@ public class ListComponent
         }
 
         if (this.mouseInRegion(this.lastX, this.lastY, x, y)) {
-            for (final ButtonElement b : this.buttons) {
+            for (final ButtonElement b : this.filteredButtons) {
                 if (b.mouseClicked(this.minecraft, x, y)) {
-                    for (final ButtonElement b2 : this.buttons) {
+                    for (final ButtonElement b2 : this.filteredButtons) {
                         b2.enabled = true;
                     }
 
@@ -191,6 +262,18 @@ public class ListComponent
         }
     }
 
+    @Override
+    public void onKeyDown(int keyCode, char c) {
+        super.onKeyDown(keyCode, c);
+        this.searchBar.textboxKeyTyped(c, keyCode);
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+        searchBar.updateCursorCounter();
+    }
+
     @Override
     public void mouseMovedOrUp(final int x, final int y, final int button) {
         super.mouseMovedOrUp(x, y, button);
@@ -205,15 +288,15 @@ public class ListComponent
         final @NotNull TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque1i(0xA0A0A0);
-        tessellator.addVertex(x, y + this.height, 0.0D);
-        tessellator.addVertex(x + this.getWidth(), y + this.height, 0.0D);
+        tessellator.addVertex(x, y + this.height - this.getSearchBarOffset(), 0.0D);
+        tessellator.addVertex(x + this.getWidth(), y + this.height - this.getSearchBarOffset(), 0.0D);
         tessellator.addVertex(x + this.getWidth(), y, 0.0D);
         tessellator.addVertex(x, y, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque1i(0x000000);
-        tessellator.addVertex(x + 1, y + this.height - 1, 0.0D);
-        tessellator.addVertex(x + this.getWidth() - 1, y + this.height - 1, 0.0D);
+        tessellator.addVertex(x + 1, y + this.height - this.getSearchBarOffset() - 1, 0.0D);
+        tessellator.addVertex(x + this.getWidth() - 1, y + this.height - this.getSearchBarOffset() - 1, 0.0D);
         tessellator.addVertex(x + this.getWidth() - 1, y + 1, 0.0D);
         tessellator.addVertex(x + 1, y + 1, 0.0D);
         tessellator.draw();
@@ -221,7 +304,7 @@ public class ListComponent
 
     private void drawScrollbar(final int x, final int y, final int mouseY) {
         final int scrollableHeight = this.getScrollableHeight();
-        final int displayRegionHeight = this.height - 2;
+        final int displayRegionHeight = this.height - 2 - this.getSearchBarOffset();
 
         if (!this.canScroll()) {
             return;
diff --git a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
index 830b7e6a7..5546ff18b 100644
--- a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -38,7 +38,7 @@ public class PlayerInput {
 		}
 		
 		if(GameSettings.KEY_SNEAK.isKeyOrMouse(keyCode, mouseCode)) {
-			if(GameSettings.SNEAK_TOGGLE.value && !this.mc.thePlayer.noPhysics) {
+			if(GameSettings.SNEAK_TOGGLE.value && !this.mc.thePlayer.hasNoPhysics()) {
 				if(pressed) {
                     this.sneak = !this.sneak;
 				}
@@ -99,7 +99,7 @@ public class PlayerInput {
             this.moveForward = -this.mc.controllerInput.joyLeft.getY();
             this.moveStrafe = -this.mc.controllerInput.joyLeft.getX();
             this.jump = this.mc.controllerInput.buttonA.isPressed();
-			if (this.mc.thePlayer.noPhysics) {
+			if (this.mc.thePlayer.hasNoPhysics()) {
                 this.sneak = this.mc.controllerInput.joyRight.getButton().isPressed();
 			} else {
 				if(this.mc.controllerInput.joyRight.getButton().pressedThisFrame()) {
@@ -117,7 +117,7 @@ public class PlayerInput {
         this.moveForward = MathHelper.clamp(this.moveForward, -1, 1);
         this.moveStrafe = MathHelper.clamp(this.moveStrafe, -1, 1);
 
-		if(entityplayer.isSneaking() && !entityplayer.noPhysics) {
+		if(entityplayer.isSneaking() && !entityplayer.hasNoPhysics()) {
             this.moveStrafe *= 0.3f;
             this.moveForward *= 0.3f;
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index aec3987af..47d2bc3f8 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -1022,6 +1022,10 @@ public class PacketHandlerClient extends PacketHandler {
             return;
         }
         if (stat.clientside) return; // Don't allow server to give client side only stats
+        if (packetStatistic.valueChange < 0 && stat.isAchievement()) {
+            this.mc.thePlayer.revokeAchievement(stat);
+            return;
+        }
         this.mc.thePlayer.addStat(stat, packetStatistic.valueChange);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index ba93e9343..4fdeb33d1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -147,7 +147,7 @@ public class ItemRenderer {
             renderFireInFirstPerson(partialTicks);
         }
 
-        if (this.mc.thePlayer.isInWall() && !this.mc.thePlayer.noPhysics) {
+        if (this.mc.thePlayer.isInWall() && !this.mc.thePlayer.hasNoPhysics()) {
             TilePos blockPos = this.mc.activeCamera.getTilePos(partialTicks);
 
             TextureRegistry.worldAtlas.bind();
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 3ae20b3f5..3fe26f5b6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1115,7 +1115,7 @@ public final class RenderGlobal
 
         final int pendingChunkSize = this.dirtyChunks.size();
 
-        float nearCheck = camera instanceof EntityCamera entityCamera && entityCamera.mob.noPhysics ? 16 : 2048;
+        float nearCheck = camera instanceof EntityCamera entityCamera && entityCamera.mob.hasNoPhysics() ? 16 : 2048;
         for (int i = 0; i < pendingChunkSize; i++) {
             final ChunkRenderer renderer = this.dirtyChunks.get(i);
             if (renderer.distanceToCameraSquared(camera) > nearCheck) {
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index e28df35d0..c2507eac2 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -62,13 +62,13 @@ public class ItemDragHandler extends Gui {
 			this.dragOverBuffer.clear();
 			if (Math.max(this.lastX, this.lastY) == Integer.MAX_VALUE) {
 				final var slot = this.container.getSlotAtPosition(mouseX, mouseY);
-				if (slot != null) dragOverBuffer.add(slot);
+				if (slot != null) this.dragOverBuffer.add(slot);
 			} else {
 				this.container.getSlotsBetweenPositions(this.lastX, this.lastY, mouseX, mouseY, this.dragOverBuffer);
 			}
 			this.lastX = mouseX;
 			this.lastY = mouseY;
-			if (this.dragOverBuffer.size() == 0) this.onDragOutsideOfSlots();
+			if (this.dragOverBuffer.isEmpty()) this.onDragOutsideOfSlots();
 			else for (final var slot : this.dragOverBuffer) onDragOverSlot(slot);
 
 			if (this.draggedSlots.size() <= 1) return;
@@ -85,15 +85,16 @@ public class ItemDragHandler extends Gui {
 			}else {
 				this.renderItemStackCount = this.draggingItemStack.stackSize / this.draggedSlots.size();
 			}
-			
+
+			int depositedCount = 0;
 			for(int i = 0; i < this.draggedSlots.size(); i++) {
-				drawSlotOverlayWhileDragging(this.draggedSlots.get(i));
+				depositedCount += drawSlotOverlayWhileDragging(this.draggedSlots.get(i));
 			}
 			
 			if(isCreativeDragging) {
 				this.renderItemStack.stackSize = 1;
 			}else {
-				this.renderItemStack.stackSize = this.draggingItemStack.stackSize - (this.draggedSlots.size() * this.renderItemStackCount);
+				this.renderItemStack.stackSize = this.draggingItemStack.stackSize - depositedCount;
 			}
 		}
 	}
@@ -117,7 +118,7 @@ public class ItemDragHandler extends Gui {
 
 	protected void onDragOutsideOfSlots() {}
 	
-	private void drawSlotOverlayWhileDragging(Slot slot) {
+	private int drawSlotOverlayWhileDragging(Slot slot) {
 		if(slot == null) throw new NullPointerException("Slot is null");
 		if(this.draggingItemStack == null) throw new NullPointerException("Stack is null!");
 
@@ -135,7 +136,9 @@ public class ItemDragHandler extends Gui {
 		if(stack != null) {
             this.renderItemStack.stackSize = Math.min(this.renderItemStack.getMaxStackSize(), this.renderItemStack.stackSize + stack.stackSize);
 		}
+		this.renderItemStack.stackSize = Math.min(this.renderItemStack.stackSize, slot.getMaxStackSize());
         this.itemElement.render(this.renderItemStack, slot.x, slot.y);
+		return this.renderItemStack.stackSize - (stack != null ? stack.stackSize : 0);
 	}
 	
 	public void mouseEvent(final int x, final int y, int button, boolean pressed) {
